"""
ngrams.py
Adapted from code by Paul Ebreo
Last changed 2019-10-09 by Amir Zeldes
"""

from random import choice
from nltk import word_tokenize
import argparse


the/DT cat in the/DT hat sat on a/DT mat

emit_counts["DT"]["the"] =2
emit_counts["DT"]["a"] =1

emit_p["DT"]["the"] = 2/3
emit_p["DT"]["a"] = 1/3

emit_p[tag][word] = emit_counts[tag][word]/sum(emit_counts[tag].values())

pairs = []
prev_pos = "."

counter = 0
for line in lines:
    if .. # this is a token line:
        pos= #get the pos column
        word = # get the word
        #do stuff
        if pos not in counts:
            counts[pos] = {}
        if word not in counts[pos]:
            counts[pos][word]= 0
            
        counts[pos][word] +=1
        if counter > 0:
            pairs.append(prev_pos, pos)
            
            prev_pos = pos
        counter+=1
    



def get_counts(context_length, training_text):
    """
    This function counts the frequencies of all continuations of each context tuple
    :param context_length: Integer, number of tokens preceding current token (use 2 for trigrams)
    :param training_text: The training data as one big string
    :return: counts: A dictionary of context tuples to dictionaries of continuation counts
    """

    counts = {}

    tokens = word_tokenize(training_text)
    for i in range(len(tokens) - context_length):
        context = []
        next_token = tokens[i + context_length]

        for j in range(context_length):
            context.append(tokens[i + j])

        # Add 1 to frequency or create new dictionary item for this tuple
        if tuple(context) in counts:
            if next_token in counts[tuple(context)]:
                counts[tuple(context)][next_token] += 1
            else:
                counts[tuple(context)][next_token] = 1
        else:
            counts[tuple(context)] = {next_token: 1}

    return counts


def generate_from_file(context_length, training_file, output_length=60):

    # Open the training file
    with open(training_file, 'r') as f:
        training_data = f.read()

    counts = get_counts(context_length, training_data)

    first_tokens = choice(list(counts.keys()))  # Choose a random first context
    output_list = list(first_tokens)
    current_context = first_tokens

    for i in range(output_length):
        next_context = max(counts[current_context], key=(counts[current_context].get))
        temp = list(current_context)
        temp.pop(0)  # Remove first token in previous context
        temp.append(next_context)  # Add new token for the next context
        next_token = temp[-1]
        next_context = tuple(temp)

        current_context = next_context

        output_list.append(next_token)

    print(" ".join(output_list))


parser = argparse.ArgumentParser()
parser.add_argument("file")

options = parser.parse_args()

generate_from_file(3,options.file)


